<template>
  <div class="patient-report">
    <div v-if="patient != null" class="grid">
      <div class="col-12">
        <div class="flex flex-direction-row justify-content-center">
          <Image src="/avatar.png" alt="Mascotte" width="150" />
          <Card style="width: 15rem; margin-bottom: 2em; box-shadow: none">
            <template #title>
              {{ patient.nom }} {{ patient.prenom }}
            </template>
            <template #subtitle>
              <div>
                <i class="pi pi-briefcase"></i> {{ patient.classe }}
              </div>
              <div>{{ calculateAge(new Date(patient.date_naissance)) }} ans</div>
              <div>{{ patient.nb_etoile }} stars</div>
            </template>
            <template #content>
              {{ patient.description }}

              <div class="mt-2">
                <span>login : {{ patient.login }}</span>
              </div>
              <div>
                <span>mot de passe : {{ patient.password }}</span>
              </div>

              <Button @click="deletePatientVerif = true" class="p-button-danger mt-2" label="Supprimer le patient" />
            </template>
          </Card>
          <div class="align-items-start">
            <Button
              class="p-button-text p-button-plain"
              v-tooltip.bottom="'Modifier les informations du patient'"
              @click="patientinfo_visible = true"
            >
              <i class="pi pi-pencil" />
            </Button>
          </div>
          <Dialog v-model:visible="patientinfo_visible">
            <template #header>
              <h3>Modifier les informations du patient</h3>
            </template>

            <form class="p-fluid">
              <div class="field">
                <label for="name">Nom</label>
                <InputText
                  id="name"
                  :placeholder="patient.nom"
                  v-model="nom"
                />
              </div>
              <div class="field">
                <label for="nsurame">Prenom</label>
                <InputText
                  id="surname"
                  :placeholder="patient.prenom"
                  v-model="prenom"
                />
              </div>
              <div class="field">
                <label for="nsurame">Description</label>
                <InputText
                  id="surname"
                  :placeholder="patient.description"
                  v-model="description"
                />
              </div>
              <div class="field">
                <label for="naissance">Date de naissance</label>
                <Calendar dateFormat="dd/mm/yy" v-model="dateNaissance" :inline="false" />
              </div>
              <div class="field">
                <label for="niveau">Niveau scolaire</label>
                <InputText
                  id="password"
                  :placeholder="patient.classe"
                  v-model="classe"
                >
                </InputText>
              </div>
            </form>

            <template #footer>
              <Button
                label="Enregistrer"
                :loading="loadPatientSave"
                @click="handleModifyPatientInfo()"
                class="p-button-success"
                icon="pi pi-check"
                autofocus
              />
            </template>
          </Dialog>
        </div>
        <div class="flex justify-content-center">
          <div class="patient-buttons">
            <h4>Toutes les listes de travail</h4>
            <Button
              label="Créer une nouvelle liste de travail"
              @click="$router.push(`/patient/${$route.params.id}/wordlist/new`)"
            />
            <Dialog v-model:visible="wordlist_visible">
              <template #header>
                <h3>Créer une nouvelle liste de mots</h3>
              </template>

              <Dropdown
                v-model="selectedAncientList"
                placeholder="A partir de..."
                :options="Object.values(lists)"
                optionLabel="name"
                style="minwidth: 14rem"
                @change="ancientlistId = selectedAncientList.id"
              />

              <template #footer>
                <router-link
                  :to="
                    ancientlistId ? `/patient/${$route.params.id}/wordlist/${ancientListId}` : `/patient/${$route.params.id}/wordlist/new`
                  "
                >
                  <Button label="Créer" class="p-button-primary" />
                </router-link>
              </template>
            </Dialog>

            <Button v-if="patient.isWorking" @click="$router.push('/patient/' + $route.params.id + '/wordlist/' + patient.work)" label="Modifier la liste de travail actuelle" />
            <div>
              <Button v-if="patient.isWorking" :loading="removeWorkLoad" class="p-button-danger" @click="removeWork()" label="Retirer le travail en cours" />
              <p v-else>Ce patient n'a pas de travail actuellement</p>
            </div>
            
            <div style="display: flex">
              <div class="search-filter">
                <h4 class="mb-2">Vos filtres</h4>
                <p class="mb-2 mt-0">Les filtres que vous avez créés</p>
                <div class="hello-searchbar">
                  <div class="flex align-items-center">
                  <i class="pi pi-search mr-2" />
                  <InputText
                      class="inputtext-searchbar"
                      type="text"
                      v-model="search"
                      placeholder="Chercher un filtre"
                  />
                  <span class="ml-2">({{ filteredFiltre.length }})</span>
                  </div>
                </div>

                <OrderList class="mt-2" v-model="filteredFiltre" listStyle="height:auto" dataKey="id">
                  <template #item="filt">
                    <div class="patient-item">
                        <div class="patient-list-detail">
                          <h5 class="mb-2 mt-0 mr-4">
                            {{ filt.item.nom }} <span class="font-light" v-if="filt.item.collaborative">(Collab)</span> <span class="font-light" v-if="patient.isWorking && filt.item.id == patient.work">(Liste utilisée)</span>
                          </h5>
                        </div>
                        <Button label="Voir" @click="$router.push('/patient/' + this.$route.params.id + '/wordlist/' + filt.item.id)"/>
                        <Button :loading="loadChangeFilter" @click="selectFilter(filt.item.id)" v-if="!patient.isWorking || filt.item.id != patient.work" class="ml-2 p-button-success" label="Selectionner"/>
                        <Button v-if="patient.isWorking && filt.item.id == patient.work" :loading="removeWorkLoad" class="p-button-danger ml-2" @click="removeWork()" label="Retirer" />
                      </div>
                  </template>
                </OrderList>
              </div>
              <div class="search-filter">
                <h4 class="mb-2">Filtres collaboratifs</h4>
                <p class="mb-2 mt-0">Découvrez les filtres créés par les autres utilisateurs</p>

                <div class="hello-searchbar">
                  <div class="flex align-items-center">
                  <i class="pi pi-search mr-2" />
                  <InputText
                      class="inputtext-searchbar"
                      type="text"
                      v-model="searchCollab"
                      placeholder="Chercher un filtre"
                  />
                  <span class="ml-2">({{ filteredCollab.length }})</span>
                  </div>
                </div>
                <OrderList class="mt-2" v-model="filteredCollab" listStyle="height:auto" dataKey="id">
                  <template #item="filt">
                    <div class="patient-item">
                        <div class="patient-list-detail">
                          <h5 class="mb-2 mt-0 mr-4">
                            {{ filt.item.nom }} <span class="font-light">par {{ filt.item.collaborativeName }}</span>
                          </h5>
                        </div>
                        <Button label="Voir" @click="$router.push('/patient/' + this.$route.params.id + '/wordlist/' + filt.item.id + '/collab')"/>
                        <Button :loading="collabLoad" @click="useCollab(filt.item.id)" class="ml-2 p-button-success" label="Utiliser"/>
                      </div>
                  </template>
                </OrderList>
              </div>
            </div>
          </div>
        </div>

        <div style="display: flex; justify-content: center">
          <div>
            <h3>Résultats</h3>
            <p>Nombre de parties du {{ String(dateFrom).substring(0, 10) }} au {{ String(dateTo).substring(0, 10)  }}</p>
            <Chart style="max-width: 400px; width: 100%" type="polarArea" :data="chartData" :options="chartOptions" />
            <Button label="Previous" @click="previousWeek()"/>
            <Button label="Next" @click="nextWeek()" :disabled="dateOffset == 1"/>
          </div>
        </div>

        <h4>Les dernières parties du patients</h4>
        <div class="m-4" style="display: grid;">
          <div class="mb-4" v-for="(item, index) in results" :key="index" style="border: 1px solid #252525; justify-self: center; width: 100%; max-width: 800px; border-radius: 10px; padding: 20px">
            <div class="flex" style="justify-content: space-between; align-items: center">
              <div>
                <h4 class="m-0">{{ item.nom_jeu }} <span style="font-size: 13px; font-weight: 300">{{ new Date(item.date).toLocaleDateString('fr-FR') }} à {{ new Date(item.date).getHours().toString().padStart(2, '0') }}h{{ new Date(item.date).getMinutes().toString().padStart(2, '0') }}</span></h4>
                <h5 style="margin: 0"><span v-if="item.id_filtre in filtreIndex" style="cursor: pointer; color: blue; text-decoration: underline" @click="$router.push('/patient/' + $route.params.id + '/wordlist/' + item.id_filtre)">Voir le filtre</span><span v-else style="font-weight: 300">(Le filtre n'est plus disponible)</span></h5>
              </div>
              <div>
                <h3 class="m-0">{{ item.difficulte }}</h3>
                <p class="m-0">{{ parseFloat(item.taux_reussite).toFixed(1) }}/1</p>
              </div>
            </div>
            <div v-if="item.nom_jeu == 'Ecoute et choisis' && item.difficulte != '[..] Phonetique'" style="display: grid; grid-template-columns: repeat(3, minmax(0, 1fr)); gap: 1rem; margin-top: 5px">
              <div v-for="(itt, idd) in item.mots_rates" :key="idd">
                <h5 style="margin: 0; color: red">Non trouvé</h5>
                <p style="margin: 0; font-weight: bold">{{ itt.word }}</p>
              </div>
            </div>
            <div v-else style="display: grid; grid-template-columns: repeat(3, minmax(0, 1fr)); gap: 0.5rem; margin-top: 5px">
              <div v-for="(itt, idd) in item.mots_rates" :key="idd">
                <h5 style="margin: 0; color: red">{{ itt.count }} erreur(s)</h5>
                <p style="margin: 0; font-weight: bold">{{ itt.word }}</p>
              </div>
            </div>

            <hr>

            <h5 style="color: green" class="mt-0 mb-0">Mots trouvés</h5>
            <div style="display: grid; grid-template-columns: repeat(3, minmax(0, 1fr)); gap: 0.5rem; margin-top: 5px">
              <div v-for="(itt, idd) in item.find" :key="idd">
                <p style="margin: 0; font-weight: bold">{{ itt.word }}</p>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <Dialog v-model:visible="deletePatientVerif">
        <template #header>
        <h3 class="warning">Supprimer un patient</h3>
        </template>

        <p>Vous êtes sur le point de supprimer définitivement le patient <strong>{{ patient.nom }} {{ patient.prenom }}</strong> ainsi que toutes les informations qui lui sont associés.</p>
        <p>Pour valider la suppression, veuillez cliquer sur "Supprimer"</p>

        <template #footer>
        <Button
            :loading="loadRemovePatient"
            label="Supprimer"
            class="p-button-danger"
            @click="deletePatient()"
        />
        </template>
    </Dialog>
  </div>
</template>

<script>
import Chart from "primevue/chart";
import Image from "primevue/image";
import Card from "primevue/card";
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import InputText from "primevue/inputtext";
import OrderList from "primevue/orderlist";
import Calendar from "primevue/calendar";
import Dropdown from "primevue/dropdown";

import axios from 'axios'

export default {
  name: "PatientReport",
  components: {
    Chart,
    Image,
    Card,
    Button,
    OrderList,
    Dialog,
    InputText,
    Calendar,
    Dropdown,
  },
  data() {
    return {
      dateFrom: null,
      dateTo: null,
      dateToSave: null,
      dateFromSave: null,
      chartData: {
        datasets: [
          {
            data: [11, 16, 7],
            backgroundColor: [
              "#66BB6A",
              "#FFA726",
              "#26C6DA",
            ],
          },
        ],
        labels: ["Jeu de l'oie", "Ecoute et choisis", "Memory"],
      },
      chartOptions: {
        plugins: {
          legend: {
            labels: {
              color: "#495057",
            },
          },
        },
        scales: {
          r: {
            grid: {
              color: "#ebedef",
            },
          },
        },
      },
      loadPatientSave: false,
      filtreIndex: {},
      results: [],
      dateOffset: 1,

      patientinfo_visible: false,
      wordlist_visible: false,
      ancientListId: "",
      selectedAncientList: "",
      patient: null,
      nom: "",
      prenom: "",
      dateNaissance: "",
      description: "",
      classe: "",
      loadRemovePatient: false,
      deletePatientVerif: false,
      filtres: [],
      filtresCollab: [],
      collabLoad: false,
      search: "",
      searchCollab: "",
      loadChangeFilter: false,
      removeWorkLoad: false,
      lists: {
        emptylist: {
          id: null,
          name: "...à partir d'une liste vide",
        },
        list1: {
          id: 1,
          name: "Premier travail",
        },
        list2: {
          id: 2,
          name: "Deuxième travail",
        },
        list3: {
          id: 3,
          name: "Troisième travail",
        },
        list4: {
          id: 4,
          name: "Quatrième travail",
        },
        list5: {
          id: 5,
          name: "Cinquième travail",
        },
      },
    };
  },
  created() {
    if (!this.$store.state.user.isLoggedIn) {
      this.$router.push('/')
    } else {
      this.getPatient();
    }
  },
  computed: {
    filteredFiltre() {
      let filteredFil = Object.values(this.filtres);
      if (!this.search == "" && this.search) {
        filteredFil = filteredFil.filter((item) => {
          return (
            item.nom.toUpperCase().includes(this.search.toUpperCase())
          );
        });
      }
      return filteredFil;
    },
    filteredCollab() {
      let filteredFil = Object.values(this.filtresCollab);
      if (!this.searchCollab == "" && this.searchCollab) {
        filteredFil = filteredFil.filter((item) => {
          return (
            item.nom.toUpperCase().includes(this.searchCollab.toUpperCase())
          );
        });
      }
      return filteredFil;
    }
  },
  methods: {
    async useCollab(id) {
      this.collabLoad = true
      let filt = null
      for(var i in this.filtresCollab){
          if(this.filtresCollab[i].id == id){
              filt = this.filtresCollab[i]
              break;
          }
      }
      if (filt != null) {
        await axios.put("/filtres/create", {nom: String(filt.nom) + " (par " + String(filt.collaborativeName) + ")", collaborative: false, collaborativeName: "", wordList: filt.wordList, id_ortho: this.$store.state.user.id, enfant_id: this.$route.params.id}).then(res => {
          this.patient.isWorking = true
          this.patient.work = res.data
          filt.id = res.data
          filt.nom = String(filt.nom) + " (par " + String(filt.collaborativeName) + ")"
          filt.collaborative = false
          this.filtres.push(filt)
          this.collabLoad = false
        }).catch(err => {
          console.log(err)
          this.collabLoad = false
        })
      }
      this.collabLoad = false
    },
    async removeWork() {
      this.removeWorkLoad = true
      await axios.post("/filtres/work/remove", {enfant_id: this.$route.params.id}).then(res => {
        this.patient.isWorking = false
        this.removeWorkLoad = false
      }).catch(err => {
        console.log(err)
        this.removeWorkLoad = false
      })
    },
    async selectFilter(id) {
      this.loadChangeFilter = true
      await axios.post("/filtres/work", {enfant_id: this.$route.params.id, id_filtre: id}).then(res => {
        this.patient.work = id
        this.patient.isWorking = true
        this.loadChangeFilter = false
      }).catch(err => {
        console.log(err)
        this.loadChangeFilter = false
      })
    },
    previousWeek() {
      this.chartData.datasets[0].data = [0, 0, 0]
      this.dateOffset += 1
      let now = new Date(this.dateToSave), before = new Date(this.dateFromSave)
      before.setDate(before.getDate() - 7)
      now.setDate(now.getDate() - 7)
      before = before.getTime()
      now = now.getTime()
      this.dateFrom = new Date(before).toLocaleDateString('fr-FR')
      this.dateTo = new Date(now).toLocaleDateString('fr-FR')
      this.dateToSave = new Date(now)
      this.dateFromSave = new Date(before)
      for (let i = 0; i < this.results.length; i++) {
        let dat = new Date(this.results[i].date).getTime()
        if (dat >= before && now >= dat) {
          if (this.results[i].nom_jeu == "Ecoute et choisis") {
            this.chartData.datasets[0].data[1]++
          } else if (this.results[i].nom_jeu == "Jeu de l'oie") {
            this.chartData.datasets[0].data[0]++
          } else if (this.results[i].nom_jeu == "Memory") {
            this.chartData.datasets[0].data[2]++
          }
        }
      }
    },
    nextWeek() {
      if (this.dateOffset != 1) {
        this.chartData.datasets[0].data = [0, 0, 0]
        this.dateOffset -= 1
        let now = new Date(this.dateToSave), before = new Date(this.dateFromSave)
        before.setDate(before.getDate() + 7)
        now.setDate(now.getDate() + 7)
        before = before.getTime()
        now = now.getTime()
        this.dateFrom = new Date(before).toLocaleDateString('fr-FR')
        this.dateTo = new Date(now).toLocaleDateString('fr-FR')
        this.dateToSave = new Date(now)
        this.dateFromSave = new Date(before)
        for (let i = 0; i < this.results.length; i++) {
          let dat = new Date(this.results[i].date).getTime()
          if (dat >= before && now >= dat) {
            if (this.results[i].nom_jeu == "Ecoute et choisis") {
              this.chartData.datasets[0].data[1]++
            } else if (this.results[i].nom_jeu == "Jeu de l'oie") {
              this.chartData.datasets[0].data[0]++
            } else if (this.results[i].nom_jeu == "Memory") {
              this.chartData.datasets[0].data[2]++
            }
          }
        }
      }
    },
    async getPatient() {
      await axios
        .get("/enfants/search?id_ortho="+ this.$store.state.user.id +"&enfant_id=" + this.$route.params.id)
        .then((res) => {
          this.nom = res.data[0].nom
          this.prenom = res.data[0].prenom
          let split = res.data[0].date_naissance.split("-")
          res.data[0].date_naissance = new Date(split[0], parseInt(split[1]) - 1, parseInt(split[2]) + 1)
          this.dateNaissance = res.data[0].date_naissance
          this.classe = res.data[0].classe
          this.description = res.data[0].description
          this.patient = res.data[0]
        })
        .catch((error) => {
          this.$router.push('/panel')
        });
      await axios.get("/filtres?id_ortho=" + this.$store.state.user.id).then(res => {
        this.filtres = res.data
        Object.keys(this.filtres || {}).forEach(item => {
          this.filtreIndex[this.filtres[item].id] = true
        })
      }).catch(err => {
        console.log(err)
      })
      await axios.get("/filtres/collaborative?id_ortho=" + this.$store.state.user.id).then(res => {
        this.filtresCollab = res.data
      }).catch(err => {
        console.log(err)
      })
      await axios.get("/resultats?id_enfant=" + this.$route.params.id).then(response => {
        this.chartData.datasets[0].data = [0, 0, 0]
        let now = new Date(), before = new Date()
        before.setDate(now.getDate() - 7)
        before = before.getTime()
        now = now.getTime()
        this.dateFrom = new Date(before).toLocaleDateString('fr-FR')
        this.dateTo = new Date(now).toLocaleDateString('fr-FR')
        this.dateToSave = new Date(now)
        this.dateFromSave = new Date(before)
        for (let i = 0; i < response.data.length; i++) {
          let dat = new Date(response.data[i].date).getTime()
          if (dat >= before && now >= dat) {
            if (response.data[i].nom_jeu == "Ecoute et choisis") {
              this.chartData.datasets[0].data[1]++
            } else if (response.data[i].nom_jeu == "Jeu de l'oie") {
              this.chartData.datasets[0].data[0]++
            } else if (response.data[i].nom_jeu == "Memory") {
              this.chartData.datasets[0].data[2]++
            }
          }
          
          response.data[i].mots_rates = String(response.data[i].mots_rates).replaceAll('{', '').replaceAll('}', '').replaceAll(' ', '')
          let res = [], find = []
          let mrate = String(response.data[i].mots_rates).split(',')
          for (let j = 0; j < mrate.length; j++) {
            mrate[j] = mrate[j].split(':')
            let wd = ""
            for (let k = 0; k < this.$store.state.mots.length; k++) {
              if (this.$store.state.mots[k].id == mrate[j][0]) {
                wd = this.$store.state.mots[k].orthographe
                break;
              }
            }
            if (parseInt(mrate[j][1]) != 0 && response.data[i].nom_jeu != "Ecoute et choisis" || parseInt(mrate[j][1]) != 1 && response.data[i].nom_jeu == "Ecoute et choisis") {
              res.push({word: wd, count: mrate[j][1]})
            } else {
              find.push({word: wd, count: mrate[j][1]})
            }
          }
          response.data[i].mots_rates = res
          response.data[i].find = find
        }
        this.results = response.data
        this.results.sort((a, b) => {return new Date(b.date) - new Date(a.date)})
      })
    },
    async deletePatient() {
      this.loadRemovePatient = true
      await axios
        .delete("/enfants/remove?enfant_id=" + this.$route.params.id)
        .then((res) => {
          this.$store.commit("removePatient", {id: this.$route.params.id})
          this.$router.push("/panel")
        })
        .catch((error) => {
          this.loadRemovePatient = false
          console.error(error);
        });
    },
    calculateAge: function (dateDeNaissance) {
      const current = new Date();
      let thisMonth = current.getMonth();
      if (dateDeNaissance.getMonth() == thisMonth) {
        let thisDate = current.getDate();
        if (dateDeNaissance.getDate() > thisDate) {
          // same month + before date of birth : age - 1
          return current.getYear() - dateDeNaissance.getYear() - 1;
        }
        // same month + after date of birth : age
        return current.getYear() - dateDeNaissance.getYear();
        // before month of birth : age - 1
      } else if (dateDeNaissance.getMonth() > thisMonth) {
        return current.getYear() - dateDeNaissance.getYear() - 1;
      }
      // after month of birth : age
      return current.getYear() - dateDeNaissance.getYear();
    },
    async handleModifyPatientInfo() {
      this.loadPatientSave = true
      this.patient.prenom = String(this.prenom)
      this.patient.description = String(this.description)
      this.patient.date_naissance = String(new Date(this.dateNaissance).toISOString().split('T')[0])
      this.patient.classe = this.classe
      await axios.post("/enfants/update", this.patient).then(res => {
        this.patientinfo_visible = false;
        let split = this.patient.date_naissance.split("-")
        this.patient.date_naissance = new Date(split[0], parseInt(split[1]) - 1, parseInt(split[2]) + 1)
        this.dateNaissance = this.patient.date_naissance
        this.loadPatientSave = false
      }).catch (err => {
        console.log(err)
        this.loadPatientSave = false
      })
    },
  },
};
</script>

<style lang="scss">
h4 {
  margin-bottom: 0px;
}
.search-filter {
  padding: 0rem 1rem 1rem 1rem;
}
.patient-item {
  display: flex;
  align-items: center;
  padding: 0.5rem;
  width: 100%;
  text-align: left !important;

  .patient-list-detail {
    flex: 1 1 0;
  }

  .patient-niveau-icon {
    margin-right: 0.5rem;
    font-size: 0.875rem;
  }

  .patient-niveau {
    line-height: 1;
    font-size: 0.875rem;
  }
  .patient-description {
    line-height: 1;
    font-size: 0.775rem;
    margin-top: 0.2rem;
  }
}

@media screen and (max-width: 576px) {
  .patient-item {
    flex-wrap: wrap;
    text-align: center !important;

    .image-container {
      width: 100%;
      text-align: center;
    }
  }
}
.patient-report {
  margin-top: 2rem;
}

.patient-login {
  display: flex;
  align-items: center;
  flex-direction: column;
  margin-top: 2rem;
  margin-bottom: 2rem;
}

.patient-buttons > button {
  margin: 0.5rem;
}
</style>